/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_cmt_user.c
* Version      : Code Generator for RX111 V1.01.00.03 [22 Aug 2013]
* Device(s)    : R5F51111AxFM
* Tool-Chain   : CCRX
* Description  : This file implements device driver for CMT module.
* Creation Date: 2013/12/09
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cmt.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_touch.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
uint32_t itvCnt;
volatile uint32_t cmtCnt = 0;
volatile uint8_t cmtFlg;
uint8_t lpCnt;
/* End user code. Do not edit comment generated here */
//uint8_t debug_cnt;

/***********************************************************************************************************************
* Function Name: r_cmt_cmi0_interrupt
* Description  : None
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#if FAST_INTERRUPT_VECTOR == VECT_CMT0_CMI0
#pragma interrupt r_cmt_cmi0_interrupt(vect=VECT(CMT0,CMI0),fint)
#else
#pragma interrupt r_cmt_cmi0_interrupt(vect=VECT(CMT0,CMI0))
#endif
static void r_cmt_cmi0_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
/*
    if( debug_cnt == 0 )
    {
        PORT1.PMR	= 0x00;
        PORT1.PODR.BYTE	= 0x08;
        PORT1.PDR.BYTE	= 0x08;
        debug_cnt = 1;
    }
    else
    {
        PORT1.PODR.BYTE	= 0x00;
        PORT1.PDR.BYTE	= 0x08;
        debug_cnt = 0;
    }
*/
    g_touch_system.flag.timing = 1;        /* CTSU measurement timing    */
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_cmt_cmi1_interrupt
* Description  : None
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#if FAST_INTERRUPT_VECTOR == VECT_CMT1_CMI1
#pragma interrupt r_cmt_cmi1_interrupt(vect=VECT(CMT1,CMI1),fint)
#else
#pragma interrupt r_cmt_cmi1_interrupt(vect=VECT(CMT1,CMI1))
#endif
static void r_cmt_cmi1_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	itvCnt++;
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_cmt_cmi2_interrupt
* Description  : None
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#if FAST_INTERRUPT_VECTOR == VECT_CMT2_CMI2
#pragma interrupt r_cmt_cmi2_interrupt(vect=VECT(CMT2,CMI2),fint)
#else
#pragma interrupt r_cmt_cmi2_interrupt(vect=VECT(CMT2,CMI2))
#endif
static void r_cmt_cmi2_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	lpCnt++;
	if(lpCnt >= 1){
		cmtFlg = 1;
		lpCnt = 0;
	}
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_cmt_cmi3_interrupt
* Description  : None
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#if FAST_INTERRUPT_VECTOR == VECT_CMT3_CMI3
#pragma interrupt r_cmt_cmi3_interrupt(vect=VECT(CMT3,CMI3),fint)
#else
#pragma interrupt r_cmt_cmi3_interrupt(vect=VECT(CMT3,CMI3))
#endif
static void r_cmt_cmi3_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	cmtCnt++;
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
void cmt_delayms(const uint32_t ms){
	cmt_delayus(ms*1000);
}

void cmt_delayus(const uint32_t us){
	R_CMT3_Stop();
	R_CMT3_Start();
		while(cmtCnt < us){
			/* wait */
		}
	R_CMT3_Stop();
	cmtCnt = 0;
}
/* End user code. Do not edit comment generated here */
