/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_hardware_setup.c
* Version      : Code Generator for RX113 V1.01.00.02 [31 Jul 2014]
* Device(s)    : R5F51136AxFP
* Tool-Chain   : CCRX
* Description  : This file implements system initializing function.
* Creation Date: 2015/03/17
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_ctsu.h"
#include "r_cgc.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_cg_cmt.h"
#include "r_sci.h"
#include "r_cg_icu.h"
#include "r_cg_tmr.h"
#include "r_cg_riic.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_Systeminit
* Description  : This function initializes every macro.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_Systeminit(void)
{
    /* Enable writing to registers related to operating modes, LPC, CGC and software reset */
    SYSTEM.PRCR.WORD = 0xA507U;

    /* Enable writing to MPC pin function control registers */
    MPC.PWPR.BIT.B0WI  = 0U;
    MPC.PWPR.BIT.PFSWE = 1U;

    /* Set peripheral settings */
    R_CGC_Create();

	R_SCI12_Create();	//SPI Communication
	R_SCI12_Start();		//Initialize

	R_ICU_Create();
	R_ICU_IRQ5_Start();

	R_SCI1_Create();	//Bluetooth Communication

	R_RIIC0_Create();	//I2C Communication

	R_CMT1_Create();	//IR Receive Timer
	R_CMT2_Create();	//gadget flg timer
	R_CMT3_Create();	//cmt_delay

	R_TMR0_Create();	//Speaker timer
	R_TMR2_Create();	//IR Transmit Timer

    PORTB.PDR.BYTE = 0xEB;
   	PORTB.PMR.BYTE = 0x00;

   	PORTB.PODR.BYTE = 0x01;

   	PORTA.PDR.BIT.B6 = 1;
	PORTA.PMR.BIT.B6 = 0;
    /* Disable writing to MPC pin function control registers */
    MPC.PWPR.BIT.PFSWE = 0U;
    MPC.PWPR.BIT.B0WI  = 1U;

    /* Enable protection */
    SYSTEM.PRCR.WORD = 0xA500U;

#if (MCU_SERIES_T == R5F5230 || MCU_SERIES_T == R5F5231)
    /* Enable writing to registers related to operating modes, LVD and battery backup function */
    SYSTEM.PRCR.WORD = 0xA508U;

    /*  Disable writing to VBATT Control Register  */
    SYSTEM.VBATTCR.BYTE = 0x81U;

    /* Enable protection */
    SYSTEM.PRCR.WORD = 0xA500U;
#endif    // (MCU_SERIES_T == R5F5230 || MCU_SERIES_T == R5F5231)
}


/***********************************************************************************************************************
* Function Name: HardwareSetup
* Description  : This function initializes hardware setting.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void HardwareSetup(void)
{
	R_Systeminit();
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
