﻿/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : 2.00
* Device(s)    : R5F5113xAxFP,R5F5231xAxFP,R5F51305AxFN
* Tool-Chain   : CC-RX Compiler ( V2.02.00 )
* OS           : -
* H/W Platform : -
* Description  : This file is system main.
* Operation    : Compile and download the sample code. Click �eReset Go�f to start the software.
* Limitations  : -
***********************************************************************************************************************/

/***********************************************************************************************************************
* History      : DD.MM.YYYY Version    Description
*              : xx.xx.2014   1.00     First Release
*              : 05.02.2015   2.00     First Release
***********************************************************************************************************************/

/***********************************************************************************************************************
* Pragma directive
***********************************************************************************************************************/

/***********************************************************************************************************************
* Includes <System Includes> , �gProject Includes�h
***********************************************************************************************************************/
/* System include header */
#include "r_cg_macrodriver.h"

/* H/W include header */
#include "iodefine.h"
#include "r_mpc.h"
#include "r_ctsu.h"
#include "r_cgc.h"
#include "r_dtc.h"
#include "r_cg_cmt.h"
#include "r_cg_icu.h"
#include "r_cg_tmr.h"
#include "r_cg_riic.h"

#ifdef SCI_SERIAL_USE
    #include "r_sci.h"
#endif    // SCI_SERIAL_USE

#ifdef  USB_SERIAL_USE
/* USB H/W include header */
#include "r_usb_ctypedef.h"             /* Type define */
#include "r_usb_ckernelid.h"            /* Kernel ID definition */
#include "r_usb_usrconfig.h"            /* System definition */
#include "r_usb_cdefusbip.h"            /* USB-FW Library Header */
#include "r_usb_usrconfig.h"            /* System definition, USB-FW Library Header */
#include "r_usb_api.h"                  /* USB API public function header */
#include "hw_resource.h"
#include "r_usb_pcdc_driver.h"
#include "r_usb_pcdc_define.h"
#include "r_usb_pcdc_api.h"
#endif  // USB_SERIAL_USE

/* S/W include header */
#ifndef _USERCLASS_H_

#define _USERCLASS_H_

#include "r_cg_userdefine.h"
#include "r_detectIR.h"
#endif
#include "r_touch.h"
#include "r_touch_API.h"

#include "r_serial_control.h"

/***********************************************************************************************************************
* Macro definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
* Typedef definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
* Private global variables and functions
***********************************************************************************************************************/
uint8_t sendDataArr[3];
uint8_t sendDataLength;
struct function FUNC;
uint8_t seeData[18] = {0,};

/***********************************************************************************************************************
* Exported global variables and functions (to be accessed by other files)
***********************************************************************************************************************/
#ifdef USB_SERIAL_USE
USB_STATIC volatile uint8_t g_usb_suspend_flag;
USB_STATIC volatile uint8_t g_usb_int_key_flag;
#endif    // USB_SERIAL_USE

/* functions */
void       main(void);
void 	   detectIR(void);
void	   request_SPK(uint16_t hz, uint16_t ms);
void	   request_MPU(void);
void 	   request_TOUCH(touch_result_t ts_result);
void 	   sendData(uint8_t cmd, uint8_t * const data_buf);
uint8_t *  receiveData(void);
void 	   request_BLT(void);

#ifdef USB_SERIAL_USE
void       R_Set_Workbench_Communication_Create(void);
void       R_USBPCDC_Create(void);
void       R_Set_Workbench_Communication_Data(void);
void       R_USBPCDC_Apl_Task_Switch(void);
void       usb_smpl_set_suspend_flag(uint8_t data);
uint8_t    usb_smpl_get_suspend_flag(void);
void       usb_smpl_set_intkey(uint8_t data);
uint8_t    usb_smpl_get_intkey(void);
#endif    // USB_SERIAL_USE

#ifdef SCI_SERIAL_USE
void       R_Set_Workbench_Communication_Create(void);
void       R_Set_Workbench_Communication_Data(void);
#endif    // SCI_SERIAL_USE

/***********************************************************************************************************************
* Imported global variables and functions (from other files)
***********************************************************************************************************************/
/* functions */
#ifdef USB_SERIAL_USE
extern void     usb_cpu_target_init(void);
extern void     usb_cstd_task_start(void);
extern void     usb_pcdc_task_start(void);
extern void     usb_apl_task_switch(void);
#endif    // USB_SERIAL_USE

void request(void){
	uint8_t *data_buf;
	uint8_t ledSum = 0, i = 0;
	uint8_t start[2] = {0x6B,0x00};
	uint8_t overCnt = 0;
	dataFlg = 0;

	PORTB.PODR.BYTE = 0x03;

	while(dataFlg == 0){
		cmt_delayms(10);
		PORTA.PODR.BIT.B6 = 1;
		cmt_delayms(20);
		PORTA.PODR.BIT.B6 = 0;
		overCnt++;
		if(overCnt>=60){
			FUNC.SLCT.BIT.NONE = 1;
			R_SCI1_Start_OnlyTX();
			PORTB.PODR.BYTE = 0x49;
			cmt_delayms(500);
			return;
		}
	}

	PORTB.PODR.BYTE = 0x0B;
	dataFlg = 0;

	while(data_buf[0] != 2 && data_buf[17] != 3){
		data_buf = receiveData();
	}

	for(i = 0 ; i < 18 ; i++){
		seeData[i] = data_buf[i];
	}

	FUNC.CMD.BYTE = data_buf[1];
	PORTB.PODR.BYTE = 0x2B;
	if(FUNC.CMD.BIT.SET == 1){
		FUNC.SLCT.BYTE = data_buf[2];

		if(FUNC.SLCT.BIT.IR == 1){
			R_TMR2_Start();
			PORTA.PDR.BIT.B4 = 1;
			PORTA.PMR.BIT.B4 = 0;
			ledSum |= 0x01;
		}else if(FUNC.SLCT.BIT.IR == 3){
			R_ICU_IRQ6_Start();
			R_CMT1_Start();
			ledSum |= 0x02;
		}

		if(FUNC.SLCT.BIT.BLTTOC == 1){
			R_CMT2_Start();
			R_SCI1_Start();
			ledSum |= 0x08;
		}else if(FUNC.SLCT.BIT.BLTTOC == 2){
			R_SCI1_Start();
			R_SCI1_Serial_Receive((uint8_t *)&g_rx_char, 1);
			ledSum |= 0x20;
		}

		if(FUNC.SLCT.BIT.SPK == 1){
			R_TMR0_Start();
			PORT0.PDR.BIT.B5 = 1;
			PORT0.PMR.BIT.B5 = 0;
			ledSum |= 0x40;
		}

		if(FUNC.SLCT.BIT.MPU6050 == 1){
			R_RIIC0_Start();
			R_RIIC0_Master_Send(0x68,start,2);
			ledSum |= 0x80;
		}
	}
	if(ledSum == 0){
		PORTB.PODR.BYTE = 0xEB;
		cmt_delayms(150);
		PORTB.PODR.BYTE = 0x00;
		cmt_delayms(100);

		PORTB.PODR.BYTE = 0xEB;
		cmt_delayms(150);
		PORTB.PODR.BYTE = 0x00;
		cmt_delayms(100);

		PORTB.PODR.BYTE = 0xEB;
		cmt_delayms(150);
		PORTB.PODR.BYTE = 0x00;
		cmt_delayms(100);

		FUNC.SLCT.BIT.NONE = 1;
		PORTB.PODR.BYTE = 0x49;
		cmt_delayms(500);
		return;
	}
	PORTB.PODR.BYTE = 0x6B;
	cmt_delayms(250);
	PORTB.PODR.BYTE = ledSum;
	cmt_delayms(500);
}

/***********************************************************************************************************************
* Function Name: main
* Description  : System main function
* Arguments    : none
* Return Value : none
***********************************************************************************************************************/
void main(void)
{
    uint8_t        method;
    uint8_t        ret_val;
    touch_result_t ts_result;

    uint8_t *data_buf;
    uint16_t freq,time;
    uint8_t i = 0;
    method = 0;


    ret_val = R_Set_Cap_Touch_Create( method );                    /* Capacitive touch create API call                */
    if (_0_SUCCESS == ret_val)                                     /* Create result check                             */
    {
        g_ctsu_soft_mode = CTSU_READY_MODE;                        /* CTSU measurement ready mode setting              */
    }
    else
    {
        g_ctsu_soft_mode = CTSU_STOP_MODE;                         /* CTSU measurement stop mode setting               */
    }

#if defined(USB_SERIAL_USE) || defined(SCI_SERIAL_USE)
    R_Set_Workbench_Communication_Create();                        /* Workbench communication function create API call */
#endif    // defined(USB_SERIAL_USE) || defined(SCI_SERIAL_USE)

    R_CMT0_Create();                                               /* CMT0 create API call                            */
    R_CMT0_Start();                                                /* CMT0 start API call                             */

    SerialCommandInitial();                                        /* Initialize serial command communication task    */
    PORTB.PMR.BYTE = 0x00;
    PORTB.PODR.BYTE = 0x00;
	dataFlg = 0;
    while (1U)                                      /* Main loop                                       */
    {
    	if(dataFlg == 1){

    		if(FUNC.SLCT.BIT.NONE != 1){
        		while(data_buf[0] != 2 && data_buf[17] != 3){
    				data_buf = receiveData();
    			}
        		FUNC.CMD.BYTE = data_buf[1];

        		if(FUNC.CMD.BIT.SPK){
        			freq = (data_buf[2] << 8) | data_buf[3];
        			time = (data_buf[4] << 8) | data_buf[5];
        			request_SPK(freq, time);
        		}else if(FUNC.CMD.BIT.MPU6050){
        			request_MPU();
        		}else if(FUNC.CMD.BIT.IR == 1){
        			sendArr = IR_send(data_buf[2],data_buf[3]);
        		}else if(FUNC.CMD.BIT.LED){
        			PORTB.PODR.BYTE = data_buf[2];
        		}else if(FUNC.CMD.BIT.BLTTOC == 2){
        			R_SCI1_AsyncTransmit(&data_buf[2],1);
        		}

        		for(i = 0 ; i < 18 ; i++){
        			data_buf[i] = 0;
        		}
    		}
    		dataFlg = 0;
    	}

    	if(rxFlg == 1){
    		request_BLT();
    		rxFlg = 0;
    	}

    	if(FUNC.SLCT.BIT.IR == 3){
    		detectIR();
    	}

#if defined(USB_SERIAL_USE) || defined(SCI_SERIAL_USE)
        R_Set_Workbench_Communication_Data();
#endif    // defined(USB_SERIAL_USE) || defined(SCI_SERIAL_USE)

        if (_1_TIMING == g_touch_system.flag.timing)
        {
            g_touch_system.flag.timing = 0;
            R_Set_Cap_Touch_Measurement_Start( method );
            if (_00_GET_OK == R_Get_Cap_Touch_Data_Check( method ))
            {
                if (_1_FINISH == R_Get_Cap_Touch_Initial_Status())
                {
                    if (_0_SUCCESS == R_Set_Cap_Touch_Result_Create( method ))
                    {
						ts_result = R_Get_Cap_Touch_Result( method );

							request_TOUCH(ts_result);

                    }
                }
                else
                {
                    R_Set_Cap_Touch_Initial_Tuning( method );
                }
            }
            method = R_Set_Cap_Touch_Next_Method_Change( method );

            PrepareReplayMessage(); /* Make the replay message of the serial command from Workbench */
        }
    }
}    /* End of function main() */

/***********************************************************************************************************************
* Function Name   : R_Set_Workbench_Communication_Create
* Description     : Workbench communication function create
* Arguments       : None
* Return value    : None
***********************************************************************************************************************/
void R_Set_Workbench_Communication_Create(void)
{
#ifdef SCI_SERIAL_USE        /* Uart(SCI6) */
    DTC_Set_Initial_of_SCI6();
    DTC_Set_Start_of_SCI6();
    R_SCI6_Create();                                               /* SCI6 create API call                            */
    R_SCI6_Start();                                                /* SCI6 start API call                             */
#endif    // SCI_SERIAL_USE
#ifdef USB_SERIAL_USE        /* USB function */
    R_USBPCDC_Create();                                            /* USB CDC create API call                         */
#endif    // USB_SERIAL_USE
}    /* End of function R_Set_Workbench_Communication_Create() */

/***********************************************************************************************************************
* Function Name   : R_USBPCDC_Create
* Description     :
* Arguments       : None
* Return value    : None
***********************************************************************************************************************/
void R_USBPCDC_Create(void)
{
#ifdef USB_SERIAL_USE
    SYSTEM.PRCR.WORD           = PRCR1_ENA;        /* Enables writing to the registers */
    SYSTEM.MSTPCRB.BIT.MSTPB19 = 0;                /* Module stop control register (Enable USB0 module(MSTPB19)) */
    SYSTEM.PRCR.WORD           = PRCR1_DIS;        /* Disables writing to the registers */
    usb_cpu_target_init();
    usb_smpl_set_suspend_flag(USB_NO);
    R_usb_pstd_PcdChangeDeviceState(USB_DO_INITHWFUNCTION);
    R_usb_pstd_PcdOpen();
    usb_pcdc_task_start();      /* Start Peripheral USB driver */
#endif    // USB_SERIAL_USE
}

/***********************************************************************************************************************
* Function Name   : R_Set_Workbench_Communication_Data
* Description     : Workbench communication data setting
* Arguments       : None
* Return value    : None
***********************************************************************************************************************/
void R_Set_Workbench_Communication_Data(void)
{
#ifdef SCI_SERIAL_USE        /* Uart(SCI6) */
    R_SCI6_Receive_Data_Check();
#endif    // SCI_SERIAL_USE
#ifdef  USB_SERIAL_USE       /* USB function */
    R_USBPCDC_Apl_Task_Switch();                                   /* USB switch task for nonOS                       */
#endif    // USB_SERIAL_USE
}    /* End of function R_Set_Workbench_Communication_Data() */

/***********************************************************************************************************************
* Function Name   : R_USBPCDC_Apl_Task_Switch
* Description     :
* Arguments       : None
* Return value    : None
***********************************************************************************************************************/
void R_USBPCDC_Apl_Task_Switch(void)
{
#ifdef USB_SERIAL_USE
    usb_apl_task_switch();        /* Switch task for nonOS */
#endif    // USB_SERIAL_USE
}

#ifdef  USB_SERIAL_USE
/***********************************************************************************************************************
* Function Name   : usb_smpl_set_suspend_flag
* Description     : Set resume interruptt flag
* Arguments       : uint8_t data
* Return value    : none
***********************************************************************************************************************/
void usb_smpl_set_suspend_flag(uint8_t data)
{
    g_usb_suspend_flag  = data;
}   /* End of function usb_smpl_set_suspend_flag() */

/***********************************************************************************************************************
* Function Name   : usb_smpl_get_suspend_flag
* Description     : Get resume interruptt flag
* Arguments       : none
* Return value    : g_usb_suspend_flag
***********************************************************************************************************************/
uint8_t usb_smpl_get_suspend_flag(void)
{
    return  g_usb_suspend_flag;
}   /* End of function usb_smpl_get_suspend_flag() */

/***********************************************************************************************************************
* Function Name   : usb_smpl_set_intkey
* Description     : Set external key interruptt flag
* Arguments       : uint8_t data
* Return value    : none
***********************************************************************************************************************/
void usb_smpl_set_intkey(uint8_t data)
{
    g_usb_int_key_flag  = data;
}   /* End of function usb_smpl_set_intkey() */

/***********************************************************************************************************************
* Function Name   : usb_smpl_get_intkey
* Description     : Get external key interruptt flag
* Arguments       : none
* Return value    : g_usb_int_key_flag
***********************************************************************************************************************/
uint8_t usb_smpl_get_intkey(void)
{
    return  g_usb_int_key_flag;
}   /* End of function usb_smpl_get_intkey() */

#endif  // USB_SERIAL_USE

void detectIR(void){
	uint8_t cnt = 0;
	uint16_t data = 0;
	uint16_t buf[18] = {0,};
	uint8_t dataBuf[14] = {0,};

	if(IR_detectStart()){						//Falling Edge detect
		while(1U){
			data = IR_detectData();
			if(data == 1000){					//if counter over the 1000 then; end
				cnt = 0;
				return;
			}

			if(data != 0){
				buf[cnt] = data;				//insert data into a buffer
				cnt++;
				data = 0;
			}else if(cnt == 18){				//buffer maximum then break
				cnt = 0;
				data = 0;
				FallingFlg = 0;
				break;
			}
		}

		dataBuf[0] = buf[0] >> 8;
		dataBuf[1] = buf[0] & 0xFF;
		dataBuf[2] = IR_convertData(buf,1);
		dataBuf[3] = IR_convertData(buf,10);

		sendData(0x03, dataBuf);
	}
}

void request_SPK(uint16_t hz, uint16_t ms){
	double freq = 0, time = 0;

	freq = (double)0.5/hz;
	time = (double)ms/1000;

	TMR01.TCORA = 13497040/hz;
	tmrLength = time / freq;
}

void request_MPU(void){
	static uint8_t data_buffer[14] = {0,};
	R_RIIC0_Master_Receive(0x68, 0x3B, data_buffer, 14);
	cmt_delayms(10);
	sendData(0x20, data_buffer);
	dataFlg = 0;
}

void request_BLT(void){
	uint8_t buf[14] = {0,};
	buf[0] = g_rx_char[0];
	g_rx_char[0] = 0;
	sendData(0x10, buf);
}

void request_TOUCH(touch_result_t ts_result){
	uint8_t ledbit[6] = {0x01,0x02,0x08,0x20,0x40,0x80};
    uint8_t	TScallData[6][6] = {{0,15},{1,0},{1,6},{1,7},{1,11},{1,14}};
    uint8_t i,		index = 0,   	div = 0,   	cnt = 0,	touched = 0;
    uint8_t tx_buf[14] = {0,};

    for(i = 0 ; i < 6 ; i ++){
    	index = TScallData[i][0];
    	div = TScallData[i][1];

    	if(1 == (ts_result.button[index] >> div)){
    		touched = i+49;
    		PORTB.PODR.BYTE = ledbit[i];
    	    cnt++;
    	}
    }

    if(FUNC.SLCT.BIT.NONE){
    	if(touched != 0){
        	sci1_print(&touched,1);
    	}
    	return;
    }

    if(cnt >= 1 && dataFlg != 1){
    	tx_buf[0] = PORTB.PIDR.BYTE;
    	sendData(0x40, tx_buf);
	}
}

void sendData(uint8_t cmd, uint8_t * const data_buf){
	uint8_t tx_buf[18] = {0,};
	uint8_t rx_buf[1] = {0};
	uint8_t i = 0, j = 0, check = 0;
	uint16_t sum = 0;

	tx_buf[0] = 0x02;
	tx_buf[1] = cmd;
	tx_buf[17] = 0x03;

	for(i = 2 ; i < 16; i++){
		tx_buf[i] = data_buf[i-2];
		sum += tx_buf[i];
	}
	tx_buf[16] = sum & 0xFF;

	for(i = 0 ; i < 18 ; i++){
		seeData[i] = tx_buf[i];
	}

	while(check != 18){
		check = 0;
		PORTA.PODR.BIT.B6 = 1;
		for(j = 0 ; j < 18; j++){
			R_SCI12_SPI_SR(&tx_buf[j],1,&rx_buf[0],1);
			check += rx_buf[0];
		}
		PORTA.PODR.BIT.B6 = 0;
	}
}

uint8_t * receiveData(void){
	static uint8_t * rx_buf;
	uint8_t tx_buf[2] = {0,18};
	uint8_t i = 0, flg = 0;
	uint16_t sum = 0;

	R_SCI12_SPI_SR(&tx_buf[0],1,&rx_buf[0],1);
	if(rx_buf[0] == 0x02){
		R_SCI12_SPI_SR(&tx_buf[0],1,&rx_buf[1],1);
		for(i = 2 ; i < 16 ; i++){
			R_SCI12_SPI_SR(&tx_buf[0],1,&rx_buf[i],1);
			sum += rx_buf[i];
		}

		sum = sum & 0xFF;
		R_SCI12_SPI_SR(&tx_buf[0],1,&rx_buf[16],1);
		if(rx_buf[16] == sum) flg = 1;

		R_SCI12_SPI_SR(&tx_buf[flg],1,&rx_buf[17],1);
		if(rx_buf[17] == 0x03 && flg == 1){
			return rx_buf;
		}
	}
	return 0;
}
/***********************************************************************************************************************
* End of file
***********************************************************************************************************************/
